﻿/********************************** (C) COPYRIGHT *******************************
* File Name          : HID USB Relay demo
* Author             : HU QI
* Version            : V1.0
* Date               : 2018/10/20
* Description        : HID USB Relay demo
* Co.                : ShangHai QiYuanFei Co.,Ltd
*******************************************************************************/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using HidSharp;
using HidSharp.Reports;
using HidSharp.Reports.Encodings;

namespace USBHIDRelay
{
    public partial class Form1 : Form
    {
        HidDevice device;
        HidStream stream;      
        public Form1()
        {
    
            InitializeComponent();
            var list = DeviceList.Local;
            var hidDeviceList = list.GetHidDevices().ToArray();
            foreach (HidDevice dev in hidDeviceList)
            {
                if (dev.ProductID == 0x2018 && dev.VendorID == 0x0519)
                {
                    comboBox1.Items.Add(dev.GetSerialNumber());
                    comboBox1.SelectedIndex = 1;
                }
                else
                {
                    comboBox1.SelectedIndex = 0;
                    comboBox1.Items[comboBox1.SelectedIndex] = "no Relay";
                    
                }
            } 
            
        }
        
        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf1};
            byte[] SendCloseCommand = new byte[] { 0x00, 0x01};
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018,1,comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox1.Enabled = true;
                stream = device.Open();
                if (checkBox1.Checked)
                {
                    label1.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label1.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                checkBox1.Enabled = false;
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }

        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf2};
            byte[] SendCloseCommand = new byte[] { 0x00, 0x02};
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox2.Enabled = true;
                stream = device.Open();
                if (checkBox2.Checked)
                {
                    label2.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label2.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                checkBox2.Enabled = false;
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf3};
            byte[] SendCloseCommand = new byte[] { 0x00, 0x03};
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox3.Enabled = true;
                stream = device.Open();
                if (checkBox3.Checked)
                {
                    label3.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label3.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                checkBox2.Enabled = false;
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf4 };
            byte[] SendCloseCommand = new byte[] { 0x00, 0x04 };
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox4.Enabled = true;
                stream = device.Open();
                if (checkBox4.Checked)
                {
                    label4.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label4.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf5 };
            byte[] SendCloseCommand = new byte[] { 0x00, 0x05 };
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox5.Enabled = true;
                stream = device.Open();
                if (checkBox5.Checked)
                {
                    label5.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label5.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf6 };
            byte[] SendCloseCommand = new byte[] { 0x00, 0x06 };

            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox4.Enabled = true;
                stream = device.Open();
                if (checkBox6.Checked)
                {
                    label6.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label6.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf7 };
            byte[] SendCloseCommand = new byte[] { 0x00, 0x07 };
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox7.Enabled = true;
                stream = device.Open();
                if (checkBox7.Checked)
                {
                    label7.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label7.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf8 };
            byte[] SendCloseCommand = new byte[] { 0x00, 0x08 };
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox8.Enabled = true;
                stream = device.Open();
                if (checkBox8.Checked)
                {
                    label8.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label8.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xf9 };
            byte[] SendCloseCommand = new byte[] { 0x00, 0x09 };
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox9.Enabled = true;
                stream = device.Open();
                if (checkBox9.Checked)
                {
                    label9.Text = "open";
                    label8.Text = "open";
                    label7.Text = "open";
                    label6.Text = "open";
                    label5.Text = "open";
                    label4.Text = "open";
                    label3.Text = "open";
                    label2.Text = "open";
                    label1.Text = "open";
                    stream.Write(SendOpenCommand);
                }
                else
                {
                    label9.Text = "close";
                    label8.Text = "close";
                    label7.Text = "close";
                    label6.Text = "close";
                    label5.Text = "close";
                    label4.Text = "close";
                    label3.Text = "close";
                    label2.Text = "close";
                    label1.Text = "close";
                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void checkBox10_CheckedChanged(object sender, EventArgs e)
        {
            byte[] SendOpenCommand = new byte[] { 0x00, 0xfe };
            byte[] SendCloseCommand = new byte[] { 0x00, 0x0e };
            var list = DeviceList.Local;
            device = list.GetHidDevices(0x0519, 0x2018, 1, comboBox1.SelectedItem.ToString()).FirstOrDefault();
            if (device != null)
            {
                checkBox9.Enabled = true;
                stream = device.Open();
                if (checkBox10.Checked)
                {
                    stream.Write(SendOpenCommand);
                }
                else
                {

                    stream.Write(SendCloseCommand);
                }

            }
            else
            {
                MessageBox.Show("Please make sure that usb is connected correctly!");
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("https://ucreatefun.taobao.com");
            linkLabel1.LinkVisited = true; 
        }

    }
}
